const info = {"examples":[{"link":"accessible.html","title":"Accessible Map","shortdesc":"Example of an accessible map.","tags":["accessibility","tabindex"]},{"link":"mapbox-vector-tiles-advanced.html","title":"Advanced Mapbox Vector Tiles","shortdesc":"Example of a Mapbox vector tiles map with custom tile grid.","tags":["mapbox","vector","tiles","mobile"]},{"link":"center.html","title":"Advanced View Positioning","shortdesc":"This example demonstrates how a map's view can be adjusted so a geometry or coordinate is positioned at a specific pixel location.","tags":["center","rotation","openstreetmap"]},{"link":"vector-esri.html","title":"ArcGIS REST Feature Service","shortdesc":"Example of using an ArcGIS REST Feature Service with a Tile strategy.","tags":["vector","esri","ArcGIS","REST","Feature","Service","loading","server"]},{"link":"xyz-esri-4326-512.html","title":"ArcGIS REST with 512x512 Tiles","shortdesc":"Example of a XYZ source in EPSG:4326 using Esri 512x512 tiles.","tags":["xyz","esri","tilesize","customprojection"]},{"link":"attributions.html","title":"Attributions","shortdesc":"Example of a attributions visibily change on map resize, to collapse them on small maps.","tags":["attributions","openstreetmap"]},{"link":"bing-maps.html","title":"Bing Maps","shortdesc":"Example of a Bing Maps layer.","tags":["bing","bing-maps"]},{"link":"box-selection.html","title":"Box Selection","shortdesc":"Using a DragBox interaction to select features.","tags":["DragBox","feature","selection","box"]},{"link":"canvas-tiles.html","title":"Canvas Tiles","shortdesc":"Renders tiles with coordinates for debugging.","tags":["layers","openstreetmap","canvas"]},{"link":"cartodb.html","title":"CartoDB source example","shortdesc":"Example of a cartodb map.","tags":["simple","openstreetmap","attribution"]},{"link":"cluster.html","title":"Clustered Features","shortdesc":"Example of using ol/source/Cluster.","tags":["cluster","vector"]},{"link":"color-manipulation.html","title":"Color Manipulation","shortdesc":"Demonstrates color manipulation with a raster source.","tags":["color","hue","lightness","chroma"]},{"link":"extent-constrained.html","title":"Constrained Extent","shortdesc":"Example of a view with a constrained extent.","tags":["view","extent","constrain","restrict"]},{"link":"zoom-constrained.html","title":"Constrained Zoom","shortdesc":"Example of a zoom constrained view.","tags":["maptiler","zoom","minZoom","maxZoom"]},{"link":"feature-animation.html","title":"Custom Animation","shortdesc":"Demonstrates how to animate features.","tags":["animation","vector","feature","flash"]},{"link":"custom-controls.html","title":"Custom Controls","shortdesc":"Shows how to create custom controls.","tags":["custom","control"]},{"link":"custom-interactions.html","title":"Custom Interactions","shortdesc":"Example of a custom interaction.","tags":["drag","feature","vector","editing","custom","interaction"]},{"link":"es2015-custom-element.html","title":"Custom map element","shortdesc":"Example of a custom element with a map.","tags":["es2015","web-component","custom-element","shadow-dom"]},{"link":"overviewmap-custom.html","title":"Custom Overview Map","shortdesc":"Example of OverviewMap control with advanced customization.","tags":["overview","overviewmap"]},{"link":"polygon-styles.html","title":"Custom Polygon Styles","shortdesc":"Showing the vertices of a polygon with a custom style geometry.","tags":["polygon","vector","style","GeometryFunction"]},{"link":"wms-custom-proj.html","title":"Custom Tiled WMS","shortdesc":"Example of using custom coordinate transform functions.","tags":["wms","tile","tilelayer","projection"]},{"link":"button-title.html","title":"Custom Tooltips","shortdesc":"This example shows how to customize the buttons tooltips with Bootstrap.","tags":["custom","tooltip"]},{"link":"d3.html","title":"d3 Integration","shortdesc":"Example of using OpenLayers and d3 together.","tags":["d3"]},{"link":"device-orientation.html","title":"Device Orientation","shortdesc":"Listen to DeviceOrientation events.","tags":["device","orientation","gyronorm"]},{"link":"disable-image-smoothing.html","title":"Disable Image Smoothing","shortdesc":"Example of disabling image smoothing","tags":["disableimagesmoothing","xyz","maptiler","reprojection"]},{"link":"drag-and-drop.html","title":"Drag-and-Drop","shortdesc":"Example of using the drag-and-drop interaction.","tags":["drag-and-drop","gpx","geojson","igc","kml","topojson","maptiler"]},{"link":"drag-and-drop-image-vector.html","title":"Drag-and-Drop Image Vector","shortdesc":"Example of using the drag-and-drop interaction with image vector rendering.","tags":["drag-and-drop-image-vector","gpx","geojson","igc","kml","topojson","maptiler","vector","image"]},{"link":"drag-rotate-and-zoom.html","title":"Drag, Rotate, and Zoom","shortdesc":"A single interaction to drag, rotate, and zoom.","tags":["drag","rotate","zoom","interaction"]},{"link":"draw-and-modify-features.html","title":"Draw and Modify Features","shortdesc":"Example of using the ol/interaction/Draw interaction together with the ol/interaction/Modify interaction.","tags":["draw","edit","modify","vector","featureoverlay"]},{"link":"draw-features.html","title":"Draw Features","shortdesc":"Example of using the ol/interaction/Draw interaction.","tags":["draw","edit","freehand","vector"]},{"link":"draw-shapes.html","title":"Draw Shapes","shortdesc":"Using the ol/interaction/Draw to create regular shapes","tags":["draw","edit","freehand","vector"]},{"link":"dynamic-data.html","title":"Dynamic Data","shortdesc":"Example of dynamic data.","tags":["dynamic-data"]},{"link":"earthquake-clusters.html","title":"Earthquake Clusters","shortdesc":"Demonstrates the use of style geometries to render source features of a cluster.","tags":["KML","vector","style","geometry","cluster"]},{"link":"heatmap-earthquakes.html","title":"Earthquakes Heatmap","shortdesc":"Demonstrates the use of a heatmap layer.","tags":["heatmap","kml","vector","style","webgl"]},{"link":"kml-earthquakes.html","title":"Earthquakes in KML","shortdesc":"Demonstrates the use of a Shape symbolizer to render earthquake locations.","tags":["KML","vector","style","tooltip"]},{"link":"earthquake-custom-symbol.html","title":"Earthquakes with custom symbols","shortdesc":"Demonstrates the use of `toContext` to create custom icon symbols.","tags":["KML","vector","style","canvas","symbol"]},{"link":"vector-esri-edit.html","title":"Editable ArcGIS REST Feature Service","shortdesc":"Example of using an ArcGIS REST Feature Service in an editing application.","tags":["vector","esri","ArcGIS","REST","Feature","Service","loading","server","edit","updateFeature","addFeature"]},{"link":"epsg-4326.html","title":"EPSG:4326","shortdesc":"Example of a map in EPSG:4326.","tags":["epsg4326"]},{"link":"export-pdf.html","title":"Export PDF example","shortdesc":"Example of exporting a map as a PDF.","tags":["export","pdf","openstreetmap"]},{"link":"extent-interaction.html","title":"Extent Interaction","shortdesc":"Using an Extent interaction to draw an extent.","tags":["Extent","interaction","box"]},{"link":"filter-points-webgl.html","title":"Filtering features with WebGL","shortdesc":"Using WebGL to filter large quantities of features","tags":["webgl","icon","sprite","filter","feature"]},{"link":"flight-animation.html","title":"Flight Animation","shortdesc":"Demonstrates how to animate flights with ´postrender´.","tags":["animation","vector","feature","flights","arc"]},{"link":"fractal.html","title":"Fractal Rendering","shortdesc":"Example of a fractal.","tags":["fractal","vector"]},{"link":"draw-freehand.html","title":"Freehand Drawing","shortdesc":"Example using the ol/interaction/Draw interaction in freehand mode.","tags":["draw","edit","freehand","vector"]},{"link":"full-screen.html","title":"Full Screen Control","shortdesc":"Example of a full screen control.","tags":["full-screen","xyz","maptiler"]},{"link":"full-screen-source.html","title":"Full Screen Control with extended source element","shortdesc":"Example of a full screen control with a source option definition.","tags":["full-screen","source","fullScreenSource","osm","osm-maps"]},{"link":"full-screen-drag-rotate-and-zoom.html","title":"Full Screen Drag, Rotate, and Zoom","shortdesc":"Example of drag rotate and zoom control with full screen effect.","tags":["full-screen","drag","rotate","zoom","xyz","maptiler"]},{"link":"mobile-full-screen.html","title":"Full-Screen Mobile","shortdesc":"Example of a full screen map.","tags":["fullscreen","geolocation","mobile"]},{"link":"geographic.html","title":"Geographic Coordinates","shortdesc":"Using geographic coordinates for the map view.","tags":["geographic"]},{"link":"edit-geographic.html","title":"Geographic Editing","shortdesc":"Editing geometries with geographic coordinates.","tags":["geographic"]},{"link":"geojson.html","title":"GeoJSON","shortdesc":"Example of GeoJSON features.","tags":["geojson","vector","openstreetmap"]},{"link":"geojson-vt.html","title":"geojson-vt integration","shortdesc":"Slice GeoJSON into vector tiles on the fly in the browser.","tags":["mapbox","vector","tiles","geojson"]},{"link":"geolocation.html","title":"Geolocation","shortdesc":"Using geolocation to control a map view.","tags":["geolocation","openstreetmap"]},{"link":"geolocation-orientation.html","title":"Geolocation Tracking with Orientation","shortdesc":"Example of a geolocated and oriented map.","tags":["fullscreen","geolocation","orientation","mobile"]},{"link":"gpx.html","title":"GPX Data","shortdesc":"Example of using the GPX source.","tags":["GPX","maptiler"]},{"link":"here-maps.html","title":"HERE Map Tile API","shortdesc":"Example of a map with map tiles from HERE.","tags":["here","here-maps","here-tile-api"]},{"link":"wmts-hidpi.html","title":"High DPI WMTS","shortdesc":"Example of a WMTS based HiDPI layer.","tags":["hidpi","retina","wmts"]},{"link":"hit-tolerance.html","title":"Hit Tolerance","shortdesc":"Example using the hitTolerance parameter.","tags":["hitTolerance"]},{"link":"icon-color.html","title":"Icon Colors","shortdesc":"Example assigning a custom color to an icon","tags":["vector","style","icon","marker"]},{"link":"icon-negative.html","title":"Icon Pixel Operations","shortdesc":"Canvas pixel operations on a point icon.","tags":["vector","style","icon","marker","canvas","select"]},{"link":"icon-scale.html","title":"Icon Scale","shortdesc":"Example of scaling icons and labels.","tags":["vector","style","icon","label","scale"]},{"link":"icon-sprite-webgl.html","title":"Icon Sprites with WebGL","shortdesc":"Rendering many icons with WebGL","tags":["webgl","icon","sprite","point","ufo"]},{"link":"icon.html","title":"Icon Symbolizer","shortdesc":"Example using an icon to symbolize a point.","tags":["vector","style","icon","marker","popup"]},{"link":"igc.html","title":"IGC Data","shortdesc":"Example of tracks recorded from multiple paraglider flights on the same day, read from an IGC file.","tags":["complex-geometry","closest-feature","igc","opencyclemap"]},{"link":"wmts-ign.html","title":"IGN WMTS","shortdesc":"Demonstrates displaying IGN (France) WMTS layers.","tags":["french","ign","geoportail","wmts"]},{"link":"iiif.html","title":"IIIF Image API","shortdesc":"Example of a IIIF Image API source.","tags":["IIIF","IIIFImageAPI","tilesource"]},{"link":"arcgis-image.html","title":"Image ArcGIS MapServer","shortdesc":"Example of an image ArcGIS layer.","tags":["arcgis","image","dynamiclayer"]},{"link":"image-filter.html","title":"Image Filters","shortdesc":"Apply a filter to imagery","tags":["filter","imagemanipulation","maptiler"]},{"link":"image-load-events.html","title":"Image Load Events","shortdesc":"Example using image load events.","tags":["image","events","loading"]},{"link":"reprojection-image.html","title":"Image Reprojection","shortdesc":"Demonstrates client-side reprojection of single image source.","tags":["reprojection","projection","proj4js","image","imagestatic"]},{"link":"immediate-geographic.html","title":"Immediate Rendering (Geographic)","shortdesc":"Using the immediate rendering API with geometries in geographic coordinates.","tags":["immediate","geographic"]},{"link":"jsts.html","title":"JSTS Integration","shortdesc":"Example on how to use JSTS with OpenLayers.","tags":["vector","jsts","buffer"]},{"link":"kml.html","title":"KML","shortdesc":"Rendering KML with a vector source.","tags":["KML","maptiler"]},{"link":"layer-clipping.html","title":"Layer Clipping","shortdesc":"Layer clipping example","tags":["clipping","openstreetmap"]},{"link":"layer-group.html","title":"Layer Groups","shortdesc":"Example of a map with layer group.","tags":["tilejson","input","bind","group","layergroup"]},{"link":"min-max-resolution.html","title":"Layer Min/Max Resolution","shortdesc":"Show/hide layers depending on current view resolution.","tags":["minResolution","maxResolution","resolution"]},{"link":"layer-spy.html","title":"Layer Spy","shortdesc":"View a portion of one layer over another","tags":["spy","imagemanipulation","maptiler"]},{"link":"layer-swipe.html","title":"Layer Swipe","shortdesc":"Example of a Layer swipe map.","tags":["swipe","openstreetmap","maptiler"]},{"link":"layer-z-index.html","title":"Layer Z-Index","shortdesc":"Example of ordering layers using Z-index.","tags":["layer","ordering","z-index"]},{"link":"layer-zoom-limits.html","title":"Layer Zoom Limits","shortdesc":"Using minZoom and maxZoom to control layer visibility.","tags":["minZoom","maxZoom","layer"]},{"link":"lazy-source.html","title":"Lazy Source","shortdesc":"Example of setting a layer source after construction.","tags":["source"]},{"link":"layer-extent.html","title":"Limited Layer Extent","shortdesc":"Restricting layer rendering to a limited extent.","tags":["extent","tilejson"]},{"link":"line-arrows.html","title":"LineString Arrows","shortdesc":"Example of drawing arrows for each line string segment.","tags":["draw","vector","arrow"]},{"link":"localized-openstreetmap.html","title":"Localized OpenStreetMap","shortdesc":"Example of a localized OpenStreetMap map with a custom tile server and a custom attribution.","tags":["localized-openstreetmap","openseamap","openstreetmap"]},{"link":"magnify.html","title":"Magnify","shortdesc":"Show a magnified version of imager under the pointer","tags":["magnify","imagemanipulation","maptiler"]},{"link":"export-map.html","title":"Map Export","shortdesc":"Example of exporting a map as a PNG image.","tags":["export","png","openstreetmap"]},{"link":"graticule.html","title":"Map Graticule","shortdesc":"This example shows how to add a graticule layer to a map.","tags":["graticule"]},{"link":"mapbox-vector-layer.html","title":"Mapbox Vector Layer","shortdesc":"Rendering a layer with a Mapbox-hosted style.","tags":["mapbox","studio","vector","tiles"]},{"link":"mapbox-vector-tiles.html","title":"Mapbox Vector Tiles","shortdesc":"Example of a Mapbox vector tiles map.","tags":["simple","mapbox","vector","tiles"]},{"link":"mapbox-layer.html","title":"Mapbox-gl Layer","shortdesc":"Example of a Mapbox-gl-js layer integration.","tags":["simple","mapbox","vector","tiles","maptiler"]},{"link":"mapguide-untiled.html","title":"MapGuide Untiled","shortdesc":"Example of a untiled MapGuide map.","tags":["mapguide"]},{"link":"feature-move-animation.html","title":"Marker Animation","shortdesc":"Demonstrates how to move a feature along a line.","tags":["animation","feature","postrender","polyline","maptiler"]},{"link":"measure.html","title":"Measure","shortdesc":"Using a draw interaction to measure lengths and areas.","tags":["draw","edit","measure","vector"]},{"link":"modify-features.html","title":"Modify Features","shortdesc":"Editing features with the modify interaction.","tags":["modify","edit","vector"]},{"link":"modify-test.html","title":"Modify Features Test","shortdesc":"Example for testing feature modification.","tags":["modify","edit","vector"]},{"link":"mouse-position.html","title":"Mouse Position","shortdesc":"Example of a mouse position control, outside the map.","tags":["mouse-position","openstreetmap"]},{"link":"moveend.html","title":"Moveend Event","shortdesc":"Use of the moveend event.","tags":["moveend","map","event"]},{"link":"navigation-controls.html","title":"Navigation Controls","shortdesc":"Shows how to add navigation controls.","tags":["control","navigation","extent"]},{"link":"reprojection-wgs84.html","title":"OpenStreetMap Reprojection","shortdesc":"Demonstrates client-side reprojection of OpenStreetMap in WGS84.","tags":["reprojection","projection","openstreetmap","wgs84","tile"]},{"link":"scaleline-indiana-east.html","title":"OpenStreetMap Reprojection with ScaleLine Control","shortdesc":"Demonstrates client-side reprojection of OpenStreetMap to NAD83 Indiana East.","tags":["reprojection","projection","openstreetmap","nad83","tile","scaleline"]},{"link":"osm-vector-tiles.html","title":"OSM Vector Tiles","shortdesc":"Using OpenStreetMap vector tiles.","tags":["vector","tiles","osm","mapzen"]},{"link":"vector-osm.html","title":"OSM XML","shortdesc":"Example of using the OSM XML source.","tags":["vector","osmxml","loading","server","strategy","bbox","maptiler"]},{"link":"overlay.html","title":"Overlay","shortdesc":"Demonstrates overlays.","tags":["overlay","popup","bootstrap","popover"]},{"link":"overviewmap.html","title":"Overview Map Control","shortdesc":"Example of OverviewMap control.","tags":["overview","overviewmap"]},{"link":"page-scroll.html","title":"Page Scrolling","shortdesc":"Shows a map that does not interrupt page scrolling.","tags":["trackpad","mousewheel","zoom","scroll","page"]},{"link":"two-finger-pan-scroll.html","title":"Panning and page scrolling","shortdesc":"Shows a map that allows page scrolling unless two fingers or Cmd/Ctrl are used to pan the map.","tags":["trackpad","mousewheel","zoom","scroll","page"]},{"link":"permalink.html","title":"Permalink","shortdesc":"Example on how to create permalinks.","tags":["permalink","openstreetmap","history"]},{"link":"pinch-zoom.html","title":"Pinch Zoom","shortdesc":"Restrict pinch zooming to integer zoom levels.","tags":["pinch","zoom","interaction"]},{"link":"popup.html","title":"Popup","shortdesc":"Uses an overlay to create a popup.","tags":["overlay","popup"]},{"link":"preload.html","title":"Preload Tiles","shortdesc":"Example of tile preloading.","tags":["preload","bing"]},{"link":"print-to-scale.html","title":"Print to scale example","shortdesc":"Example of printing a map to a specified scale.","tags":["print","printing","scale","scaleline","export","pdf"]},{"link":"reprojection.html","title":"Raster Reprojection","shortdesc":"Demonstrates client-side raster reprojection between various projections.","tags":["reprojection","projection","proj4js","osm","wms","wmts","hidpi"]},{"link":"raster.html","title":"Raster Source","shortdesc":"Demonstrates pixelwise operations with a raster source.","tags":["raster","pixel","maptiler"]},{"link":"region-growing.html","title":"Region Growing","shortdesc":"Grow a region from a seed pixel","tags":["raster","regiongrowing","maptiler"]},{"link":"regularshape.html","title":"Regular Shapes","shortdesc":"Example of some Regular Shape styles.","tags":["vector","symbol","regularshape","style","square","cross","star","triangle","x"]},{"link":"render-geometry.html","title":"Render geometries to a canvas","shortdesc":"Example of rendering geometries to an arbitrary canvas.","tags":["render","geometry","canvas"]},{"link":"reprojection-by-code.html","title":"Reprojection with EPSG.io Search","shortdesc":"Demonstrates client-side raster reprojection of OSM to arbitrary projection","tags":["reprojection","projection","proj4js","epsg.io","graticule"]},{"link":"reusable-source.html","title":"Reusable Source","shortdesc":"Updating a tile source by changing the URL.","tags":[]},{"link":"scale-line.html","title":"Scale Line","shortdesc":"Example of a scale line.","tags":["scale-line","openstreetmap"]},{"link":"sea-level.html","title":"Sea Level","shortdesc":"Render sea level at different elevations","tags":["raster","pixeloperation","flood"]},{"link":"select-features.html","title":"Select Features","shortdesc":"Example of using the Select interaction.","tags":["select","vector"]},{"link":"select-hover-features.html","title":"Select Features by Hover","shortdesc":"Example of selecting features by hovering.","tags":["select","vector"]},{"link":"select-multiple-features.html","title":"Select multiple Features","shortdesc":"Example of selecting multiple features.","tags":["select","vector"]},{"link":"semi-transparent-layer.html","title":"Semi-Transparent Layer","shortdesc":"Example of a map with a semi-transparent layer.","tags":["transparent","osm","tilejson","css"]},{"link":"shaded-relief.html","title":"Shaded Relief","shortdesc":"Calculate shaded relief from elevation data","tags":["raster","shadedrelief"]},{"link":"side-by-side.html","title":"Shared Views","shortdesc":"Two maps share view properties","tags":["side-by-side","xyz","maptiler"]},{"link":"simple.html","title":"Simple Map","shortdesc":"Example of a simple map.","tags":["simple","openstreetmap"]},{"link":"wms-image.html","title":"Single Image WMS","shortdesc":"Example of a single image WMS layer.","tags":["wms","image"]},{"link":"wms-image-custom-proj.html","title":"Single Image WMS with Proj4js","shortdesc":"Example of integrating Proj4js for coordinate transforms.","tags":["wms","singleimage","proj4js","projection"]},{"link":"chaikin.html","title":"Smoothing lines using Chaikins algorithm","shortdesc":"This uses Chaikins algorithm to smooth drawn lines.","tags":["smooth","smoothing","chaikin"]},{"link":"snap.html","title":"Snap Interaction","shortdesc":"Example of using the snap interaction together with draw and modify interactions.","tags":["draw","edit","modify","vector","snap"]},{"link":"sphere-mollweide.html","title":"Sphere Mollweide","shortdesc":"Example of a Sphere Mollweide map with a Graticule layer.","tags":["graticule","Mollweide","projection","proj4js"]},{"link":"stamen.html","title":"Stamen Tiles","shortdesc":"Example of a Stamen tile source.","tags":["stamen","watercolor","terrain-labels","two-layers"]},{"link":"static-image.html","title":"Static Image","shortdesc":"Example of a static image layer.","tags":["staticimage","xkcd"]},{"link":"street-labels.html","title":"Street Labels","shortdesc":"Render street names.","tags":["vector","label","streets","maptiler"]},{"link":"canvas-gradient-pattern.html","title":"Styling feature with CanvasGradient or CanvasPattern","shortdesc":"Example showing the countries vector layer styled with patterns and gradients.","tags":["canvas","gradient","pattern","style"]},{"link":"svg-layer.html","title":"SVG Layer","shortdesc":"Example of a map with an interactive svg layer.","tags":["svg","layer","render","transform"]},{"link":"synthetic-lines.html","title":"Synthetic Lines","shortdesc":"Synthetic lines example.","tags":["vector"]},{"link":"synthetic-points.html","title":"Synthetic Points","shortdesc":"Synthetic points example.","tags":["vector"]},{"link":"teleport.html","title":"Teleporting Maps","shortdesc":"Example of moving a map from one target to another.","tags":["teleport","openstreetmap"]},{"link":"tile-load-events.html","title":"Tile Load Events","shortdesc":"Example using tile load events.","tags":["tile","events","loading"]},{"link":"tile-transitions.html","title":"Tile Transitions","shortdesc":"Custom configuration for opacity transitions on tiles.","tags":["fade","transition"]},{"link":"arcgis-tiled.html","title":"Tiled ArcGIS MapServer","shortdesc":"Example of a tiled ArcGIS layer.","tags":["arcgis","tile","tilelayer"]},{"link":"wms-tiled.html","title":"Tiled WMS","shortdesc":"Example of a tiled WMS layer.","tags":["wms","tile","tilelayer"]},{"link":"wms-tiled-wrap-180.html","title":"Tiled WMS Wrapping","shortdesc":"Example of a tiled WMS layer that wraps across the 180° meridian.","tags":["wms","tile","dateline","wrap","180"]},{"link":"tilejson.html","title":"TileJSON","shortdesc":"Example of a TileJSON layer.","tags":["tilejson"]},{"link":"kml-timezones.html","title":"Timezones in KML","shortdesc":"Demonstrates rendering timezones from KML.","tags":["KML","vector","style"]},{"link":"tissot.html","title":"Tissot Indicatrix","shortdesc":"Draw Tissot's indicatrices on maps.","tags":["tissot","circle"]},{"link":"topojson.html","title":"TopoJSON","shortdesc":"Demonstrates rendering of features from a TopoJSON topology.","tags":["topojson","vector","style"]},{"link":"topolis.html","title":"topolis integration","shortdesc":"Example on how to use topolis with OpenLayers.","tags":["draw","edit","vector","topology","topolis"]},{"link":"tracing.html","title":"Tracing around a polygon","shortdesc":"Example of setting up a draw interaction to easily snap to an existing feature.","tags":["draw","trace","snap","vector","topology"]},{"link":"translate-features.html","title":"Translate Features","shortdesc":"Example of a translate features interaction.","tags":["drag","translate","feature","vector","editing"]},{"link":"turf.html","title":"turf.js","shortdesc":"Example on how to use turf.js with OpenLayers.","tags":["vector","turfjs","along","distance"]},{"link":"utfgrid.html","title":"UTFGrid","shortdesc":"This example shows how to read data from a UTFGrid source.","tags":["utfgrid","tilejson"]},{"link":"layer-clipping-vector.html","title":"Vector Clipping Layer","shortdesc":"Vector Clipping Layer example","tags":["clipping","openstreetmap","vector"]},{"link":"image-vector-layer.html","title":"Vector Image Layer","shortdesc":"Example of rendering vector data as an image layer.","tags":["vector","image"]},{"link":"vector-label-decluttering.html","title":"Vector Label Decluttering","shortdesc":"Label decluttering with a custom renderer.","tags":["vector","decluttering","labels"]},{"link":"vector-labels.html","title":"Vector Labels","shortdesc":"Example of GeoJSON features with labels.","tags":["geojson","vector","openstreetmap","label"]},{"link":"vector-layer.html","title":"Vector Layer","shortdesc":"Example of a countries vector layer with country information.","tags":["vector","geojson"]},{"link":"hitdetect-vector.html","title":"Vector Layer Hit Detection","shortdesc":"Example of hit detection on a countries vector layer with country information.","tags":["vector","geojson","click","hover","hitdetection"]},{"link":"vector-tile-info.html","title":"Vector Tile Info","shortdesc":"Getting feature information from vector tiles.","tags":["vectortiles"]},{"link":"vector-tile-selection.html","title":"Vector Tile Selection","shortdesc":"Select features from vector tiles.","tags":["vectortiles","selection"]},{"link":"mapbox-style.html","title":"Vector tiles created from a Mapbox Style object","shortdesc":"Example of using ol-mapbox-style with tiles from maptiler.com.","tags":["vectortiles","mapboxstyle","ol-mapbox-style","maptiler"]},{"link":"vector-tiles-4326.html","title":"Vector tiles in EPSG:4326","shortdesc":"Example showing vector tiles in EPSG:4326 (styled using ol-mapbox-style)","tags":["vectortiles","epsg4326","mapboxstyle","ol-mapbox-style","maptiler"]},{"link":"offscreen-canvas.html","title":"Vector tiles rendered in an offscreen canvas","shortdesc":"Example of a map that delegates rendering to a worker.","tags":["worker","offscreencanvas","vector-tiles"]},{"link":"animation.html","title":"View Animation","shortdesc":"Demonstrates animated pan, zoom, and rotation.","tags":["animation"]},{"link":"min-zoom.html","title":"View Min-Zoom","shortdesc":"Demonstrates how the view's minimum zoom level can be changed.","tags":["min","zoom"]},{"link":"rotation.html","title":"View Rotation","shortdesc":"Example of a rotated map.","tags":["rotation","openstreetmap"]},{"link":"webgl-points-layer.html","title":"WebGL points layer","shortdesc":"Using a WebGL-optimized layer to render a large quantities of points","tags":["webgl","point","layer","feature"]},{"link":"vector-wfs.html","title":"WFS","shortdesc":"Example of using WFS with a BBOX strategy.","tags":["vector","WFS","bbox","loading","server","maptiler"]},{"link":"vector-wfs-getfeature.html","title":"WFS - GetFeature","shortdesc":"Example of making a WFS GetFeature request with a filter.","tags":["vector","WFS","GetFeature","filter","maptiler"]},{"link":"wkt.html","title":"WKT","shortdesc":"Example of using the WKT parser.","tags":["wkt","wellknowntext"]},{"link":"wms-custom-tilegrid-512x256.html","title":"WMS 512x256 Tiles","shortdesc":"Example of a WMS layer with 512x256px tiles.","tags":["wms","tile","non-square"]},{"link":"wms-capabilities.html","title":"WMS Capabilities Parsing","shortdesc":"Example of parsing a WMS GetCapabilities response.","tags":["wms","capabilities","getcapabilities"]},{"link":"getfeatureinfo-image.html","title":"WMS GetFeatureInfo (Image Layer)","shortdesc":"Using an image WMS source with GetFeatureInfo requests","tags":["getfeatureinfo","forEachLayerAtPixel"]},{"link":"mapserver-wms.html","example":"mapserver-wms.html","title":"MapServer WMS GetFeatureInfo (local MS4W layer)","shortdesc":"Using a local MapServer (MS4W) layer with WMS GetFeatureInfo requests","tags":"getfeatureinfo, forEachLayerAtPixel, MapServer"},{"link":"getfeatureinfo-layers.html","title":"WMS GetFeatureInfo (Layers)","shortdesc":"Shows how to fetch features per layer name in a single WMS GetFeatureInfo request\n","tags":[]},{"link":"getfeatureinfo-tile.html","title":"WMS GetFeatureInfo (Tile Layer)","shortdesc":"Issuing GetFeatureInfo requests with a WMS tiled source","tags":["getfeatureinfo","forEachLayerAtPixel"]},{"link":"wms-getlegendgraphic.html","title":"WMS GetLegendGraphic","shortdesc":"Example of a WMS GetLegendGraphic.","tags":["GetLegendGraphic","getLegendUrl","WMS"]},{"link":"wms-time.html","title":"WMS Time","shortdesc":"Example of smooth tile transitions when changing the time dimension of a tiled WMS layer.","tags":["wms","time","dimensions","transition","nexrad"]},{"link":"wms-no-proj.html","title":"WMS without Projection","shortdesc":"Example of two WMS layers using the projection EPSG:21781, which is unknown to the client.","tags":["wms","projection"]},{"link":"wmts.html","title":"WMTS","shortdesc":"Example of a WMTS source.","tags":["wmts"]},{"link":"wmts-capabilities.html","title":"WMTS Capabilities Parsing","shortdesc":"Example of parsing a WMTS GetCapabilities response.","tags":["wmts","capabilities","getcapabilities"]},{"link":"wmts-layer-from-capabilities.html","title":"WMTS Layer from Capabilities","shortdesc":"Example of a WMTS source created from a WMTS capabilities document.","tags":["wmts","capabilities","getcapabilities"]},{"link":"wmts-dimensions.html","title":"WMTS Tile Transitions","shortdesc":"Example of smooth tile transitions when changing the dimension of a WMTS layer.","tags":["wmts","parameter","transition"]},{"link":"worker.html","title":"Worker","shortdesc":"This example should be deleted.","tags":["worker"]},{"link":"xyz.html","title":"XYZ","shortdesc":"Example of a XYZ source.","tags":["xyz"]},{"link":"xyz-esri.html","title":"XYZ Esri","shortdesc":"Example of a XYZ source using Esri tiles.","tags":["xyz","esri","ArcGIS","REST"]},{"link":"xyz-retina.html","title":"XYZ Retina Tiles","shortdesc":"Example of Retina / HiDPI mercator tiles (512x512px) available as XYZ.","tags":["retina","hidpi","xyz","maptiler","@2x","devicePixelRatio"]},{"link":"zoomslider.html","title":"Zoom Sliders","shortdesc":"Example of various ZoomSlider controls.","tags":["zoom","zoomslider","slider","style","styling","css","control"]},{"link":"zoomify.html","title":"Zoomify","shortdesc":"Example of a Zoomify source.","tags":["zoomify","deepzoom","IIP","pixel","projection"]}],"wordIndex":{"180":{"144":2},"4326":{"4":1,"37":2,"163":2},"21781":{"179":1},"2x":{"187":1},"512x256":{"172":1},"512x256px":{"172":1},"512x512":{"4":2},"512x512px":{"187":1},"a":{"1":1,"2":3,"3":1,"4":1,"5":1,"6":1,"7":1,"9":1,"11":1,"12":2,"13":1,"16":1,"17":2,"19":2,"27":1,"32":1,"33":1,"34":1,"37":1,"38":2,"42":1,"44":1,"45":2,"47":1,"52":1,"53":1,"55":1,"56":1,"58":1,"59":1,"62":1,"65":1,"67":1,"72":1,"74":1,"76":1,"77":1,"80":1,"81":1,"83":3,"84":1,"85":2,"86":2,"87":2,"88":1,"89":1,"90":1,"91":2,"92":1,"95":1,"104":1,"105":1,"108":1,"110":2,"112":1,"113":2,"115":1,"117":1,"118":1,"123":2,"126":1,"127":1,"131":2,"132":1,"133":1,"136":1,"139":1,"142":1,"143":1,"144":1,"145":1,"148":1,"150":2,"151":1,"153":1,"156":1,"158":1,"159":1,"162":1,"164":2,"167":1,"168":2,"169":1,"170":2,"172":1,"173":1,"175":1,"176":1,"177":1,"178":1,"180":1,"181":1,"182":2,"183":1,"185":1,"186":1,"189":1},"accessibility":{"0":1},"accessible":{"0":2},"across":{"144":1},"add":{"86":1,"97":1},"addfeature":{"36":1},"adjusted":{"2":1},"advanced":{"1":1,"2":1,"18":1},"after":{"80":1},"algorithm":{"129":2},"allows":{"105":1},"along":{"91":1,"152":1},"an":{"0":1,"3":1,"36":2,"39":2,"58":1,"62":1,"63":1,"66":1,"108":1,"115":1,"136":1,"150":1,"155":1,"164":1,"174":1},"and":{"22":1,"25":3,"26":3,"27":2,"28":1,"46":2,"53":1,"60":1,"79":1,"83":1,"92":1,"105":1,"130":1,"135":1,"165":1},"animate":{"14":1,"41":1},"animated":{"165":1},"animation":{"14":2,"41":2,"91":2,"165":2},"another":{"76":1,"139":1},"api":{"55":2,"65":2,"70":1},"application":{"36":1},"apply":{"67":1},"arbitrary":{"115":1,"116":1},"arc":{"41":1},"arcgis":{"3":3,"4":1,"36":3,"66":3,"142":3,"186":1},"are":{"105":1},"areas":{"92":1},"around":{"150":1},"arrow":{"82":1},"arrows":{"82":2},"as":{"38":1,"85":1,"155":1,"187":1},"assigning":{"58":1},"at":{"2":1,"119":1},"attribution":{"9":1,"83":1},"attributions":{"5":3},"available":{"187":1},"based":{"56":1},"bbox":{"101":1,"169":2},"be":{"2":1,"166":1,"184":1},"between":{"111":1},"bind":{"74":1},"bing":{"6":4,"109":1},"bootstrap":{"21":1,"102":1},"box":{"7":2,"39":1},"browser":{"51":1},"buffer":{"71":1},"buttons":{"21":1},"by":{"117":1,"121":2,"125":1},"calculate":{"124":1},"can":{"2":1,"166":1},"canvas":{"8":2,"35":1,"59":2,"115":3,"135":1,"164":1},"canvasgradient":{"135":1},"canvaspattern":{"135":1},"capabilities":{"173":2,"181":2,"182":3},"cartodb":{"9":2},"center":{"2":1},"chaikin":{"129":1},"chaikins":{"129":2},"change":{"5":1},"changed":{"166":1},"changing":{"117":1,"178":1,"183":1},"chroma":{"11":1},"circle":{"147":1},"click":{"159":1},"client":{"69":1,"98":1,"99":1,"111":1,"116":1,"179":1},"clipping":{"73":3,"154":3},"closest":{"63":1},"cluster":{"10":2,"32":2},"clustered":{"10":1},"clusters":{"32":1},"cmd":{"105":1},"collapse":{"5":1},"color":{"11":3,"58":1},"colors":{"58":1},"com":{"162":1},"complex":{"63":1},"component":{"17":1},"configuration":{"141":1},"constrain":{"12":1},"constrained":{"12":2,"13":2},"construction":{"80":1},"control":{"15":1,"18":1,"44":2,"45":2,"46":1,"52":1,"79":1,"95":1,"97":1,"99":1,"103":2,"188":1},"controls":{"15":2,"97":2,"188":1},"coordinate":{"2":1,"20":1,"128":1},"coordinates":{"8":1,"48":2,"49":1,"70":1},"countries":{"135":1,"158":1,"159":1},"country":{"158":1,"159":1},"create":{"15":1,"30":1,"35":1,"106":1,"108":1},"created":{"162":1,"182":1},"cross":{"114":1},"css":{"123":1,"188":1},"ctrl":{"105":1},"current":{"75":1},"custom":{"1":1,"14":1,"15":3,"16":3,"17":3,"18":1,"19":2,"20":2,"21":2,"35":2,"58":1,"83":2,"141":1,"156":1},"customization":{"18":1},"customize":{"21":1},"customprojection":{"4":1},"d3":{"22":3},"data":{"31":3,"54":1,"63":1,"124":1,"153":1,"155":1},"dateline":{"144":1},"day":{"63":1},"debugging":{"8":1},"decluttering":{"156":3},"deepzoom":{"189":1},"definition":{"45":1},"delegates":{"164":1},"deleted":{"184":1},"demonstrates":{"2":1,"11":1,"14":1,"32":1,"33":1,"34":1,"35":1,"41":1,"64":1,"69":1,"91":1,"98":1,"99":1,"102":1,"111":1,"112":1,"116":1,"146":1,"148":1,"165":1,"166":1},"depending":{"75":1},"detection":{"159":2},"device":{"23":2},"deviceorientation":{"23":1},"devicepixelratio":{"187":1},"different":{"119":1},"dimension":{"178":1,"183":1},"dimensions":{"178":1},"disable":{"24":1},"disableimagesmoothing":{"24":1},"disabling":{"24":1},"displaying":{"64":1},"distance":{"152":1},"document":{"182":1},"does":{"104":1},"dom":{"17":1},"dpi":{"56":1},"drag":{"16":1,"25":3,"26":3,"27":3,"46":3,"151":1},"dragbox":{"7":2},"draw":{"28":3,"29":3,"30":3,"39":1,"43":2,"82":1,"92":2,"130":2,"147":1,"149":1,"150":2},"drawing":{"43":1,"82":1},"drawn":{"129":1},"drop":{"25":3,"26":3},"dynamic":{"31":3},"dynamiclayer":{"66":1},"each":{"82":1},"earthquake":{"32":1,"34":1},"earthquakes":{"33":1,"34":1,"35":1},"easily":{"150":1},"east":{"99":1},"edit":{"28":1,"29":1,"30":1,"36":1,"43":1,"92":1,"93":1,"94":1,"130":1,"149":1},"editable":{"36":1},"editing":{"16":1,"36":1,"49":2,"93":1,"151":1},"effect":{"46":1},"element":{"17":3,"45":1},"elevation":{"124":1},"elevations":{"119":1},"epsg":{"4":1,"37":2,"116":2,"163":2,"179":1},"epsg4326":{"37":1,"163":1},"es2015":{"17":1},"esri":{"3":1,"4":2,"36":1,"186":3},"event":{"96":3},"events":{"23":1,"68":3,"140":3},"example":{"0":1,"1":1,"2":1,"3":1,"4":1,"5":1,"6":1,"9":2,"10":1,"12":1,"13":1,"16":1,"17":1,"18":1,"20":1,"21":1,"22":1,"24":1,"25":1,"26":1,"28":1,"29":1,"31":1,"36":1,"37":1,"38":2,"42":1,"43":1,"44":1,"45":1,"46":1,"47":1,"50":1,"53":1,"54":1,"55":1,"56":1,"57":1,"58":1,"60":1,"62":1,"63":1,"65":1,"66":1,"68":1,"71":1,"73":1,"74":1,"77":1,"78":1,"80":1,"82":1,"83":1,"85":1,"86":1,"88":1,"89":1,"90":1,"94":1,"95":1,"101":1,"103":1,"106":1,"109":1,"110":2,"114":1,"115":1,"118":1,"120":1,"121":1,"122":1,"123":1,"126":1,"127":1,"128":1,"130":1,"131":1,"132":1,"133":1,"135":1,"136":1,"137":1,"138":1,"139":1,"140":1,"142":1,"143":1,"144":1,"145":1,"149":1,"150":1,"151":1,"152":1,"153":1,"154":1,"155":1,"157":1,"158":1,"159":1,"162":1,"163":1,"164":1,"167":1,"169":1,"170":1,"171":1,"172":1,"173":1,"177":1,"178":1,"179":1,"180":1,"181":1,"182":1,"183":1,"184":1,"185":1,"186":1,"187":1,"188":1,"189":1},"existing":{"150":1},"export":{"38":2,"85":2,"110":1},"exporting":{"38":1,"85":1},"extended":{"45":1},"extent":{"12":3,"39":4,"81":3,"97":1},"fade":{"141":1},"feature":{"3":3,"7":1,"14":1,"16":1,"36":3,"40":1,"41":1,"63":1,"91":2,"94":1,"135":1,"150":1,"151":1,"160":1,"168":1},"featureoverlay":{"28":1},"features":{"7":1,"10":1,"14":1,"28":1,"29":1,"32":1,"40":2,"50":1,"93":2,"94":1,"120":1,"121":2,"122":2,"148":1,"151":2,"157":1,"161":1,"175":1},"fetch":{"175":1},"file":{"63":1},"filter":{"40":2,"67":2,"170":2},"filtering":{"40":1},"filters":{"67":1},"fingers":{"105":1},"flash":{"14":1},"flight":{"41":1},"flights":{"41":2,"63":1},"flood":{"119":1},"fly":{"51":1},"for":{"8":1,"48":1,"82":1,"94":1,"128":1,"141":1},"foreachlayeratpixel":{"174":1,"176":1},"fractal":{"42":3},"france":{"64":1},"freehand":{"29":1,"30":1,"43":3},"french":{"64":1},"from":{"55":1,"63":2,"113":1,"124":1,"139":1,"146":1,"148":1,"153":1,"160":1,"161":1,"162":2,"182":2},"full":{"44":3,"45":3,"46":3,"47":2},"fullscreen":{"47":1,"53":1},"fullscreensource":{"45":1},"functions":{"20":1},"geographic":{"48":3,"49":3,"70":3},"geojson":{"25":1,"26":1,"50":3,"51":3,"157":2,"158":1,"159":1},"geolocated":{"53":1},"geolocation":{"47":1,"52":3,"53":2},"geometries":{"32":1,"49":1,"70":1,"115":2},"geometry":{"2":1,"19":1,"32":1,"63":1,"115":1},"geometryfunction":{"19":1},"geoportail":{"64":1},"getcapabilities":{"173":2,"181":2,"182":1},"getfeature":{"170":3},"getfeatureinfo":{"174":3,"175":2,"176":3},"getlegendgraphic":{"177":3},"getlegendurl":{"177":1},"getting":{"160":1},"gl":{"89":2},"gpx":{"25":1,"26":1,"54":3},"gradient":{"135":1},"gradients":{"135":1},"graticule":{"86":3,"116":1,"131":2},"grid":{"1":1},"group":{"74":2},"groups":{"74":1},"grow":{"113":1},"growing":{"113":1},"gyronorm":{"23":1},"heatmap":{"33":3},"here":{"55":5},"hide":{"75":1},"hidpi":{"56":2,"111":1,"187":2},"high":{"56":1},"history":{"106":1},"hit":{"57":1,"159":2},"hitdetection":{"159":1},"hittolerance":{"57":2},"hosted":{"87":1},"hover":{"121":1,"159":1},"hovering":{"121":1},"how":{"2":1,"14":1,"15":1,"21":1,"41":1,"71":1,"86":1,"91":1,"97":1,"106":1,"149":1,"152":1,"153":1,"166":1,"175":1},"hue":{"11":1},"icon":{"35":1,"40":1,"58":3,"59":3,"60":2,"61":2,"62":3},"icons":{"60":1,"61":1},"igc":{"25":1,"26":1,"63":3},"ign":{"64":3},"iiif":{"65":3},"iiifimageapi":{"65":1},"iip":{"189":1},"image":{"24":2,"26":4,"65":2,"66":3,"67":1,"68":3,"69":3,"85":1,"127":3,"128":1,"133":2,"155":3,"174":2},"imagemanipulation":{"67":1,"76":1,"84":1},"imager":{"84":1},"imagery":{"67":1},"imagestatic":{"69":1},"immediate":{"70":3},"in":{"4":1,"34":1,"36":1,"37":1,"43":1,"51":1,"70":1,"98":1,"146":1,"163":2,"164":1,"175":1},"index":{"78":3},"indiana":{"99":1},"indicatrices":{"147":1},"indicatrix":{"147":1},"info":{"160":1},"information":{"158":1,"159":1,"160":1},"input":{"74":1},"integer":{"107":1},"integrating":{"128":1},"integration":{"22":1,"51":1,"71":1,"89":1,"149":1},"interaction":{"7":1,"16":2,"25":1,"26":1,"27":2,"28":4,"29":2,"30":1,"39":3,"43":2,"92":1,"93":1,"107":1,"120":1,"130":2,"150":1,"151":1},"interactions":{"16":1,"130":1},"interactive":{"136":1},"interrupt":{"104":1},"into":{"51":1},"io":{"116":2},"is":{"2":1,"179":1},"issuing":{"176":1},"js":{"89":1,"152":2},"jsts":{"71":3},"kml":{"25":1,"26":1,"32":1,"33":1,"34":2,"35":1,"72":3,"146":3},"label":{"60":1,"134":1,"156":2,"157":1},"labels":{"60":1,"132":1,"134":1,"156":1,"157":2},"large":{"40":1,"168":1},"layer":{"6":1,"33":1,"56":1,"66":1,"73":2,"74":2,"75":1,"76":2,"77":2,"78":2,"79":3,"80":1,"81":2,"86":1,"87":2,"89":2,"123":2,"127":1,"131":1,"133":1,"135":1,"136":3,"142":1,"143":1,"144":1,"145":1,"154":2,"155":2,"158":2,"159":2,"168":3,"172":1,"174":1,"175":1,"176":1,"178":1,"182":1,"183":1},"layergroup":{"74":1},"layers":{"8":1,"64":1,"75":1,"78":1,"132":1,"175":1,"179":1},"lazy":{"80":1},"lengths":{"92":1},"level":{"119":2,"166":1},"levels":{"107":1},"lightness":{"11":1},"limited":{"81":2},"limits":{"79":1},"line":{"82":1,"91":1,"118":3},"lines":{"129":2,"137":2},"linestring":{"82":1},"listen":{"23":1},"load":{"68":2,"140":2},"loading":{"3":1,"36":1,"68":1,"101":1,"140":1,"169":1},"localized":{"83":3},"location":{"2":1},"locations":{"34":1},"magnified":{"84":1},"magnify":{"84":2},"making":{"170":1},"manipulation":{"11":2},"many":{"61":1},"map":{"0":2,"1":1,"2":1,"5":1,"9":1,"17":2,"18":1,"37":1,"38":1,"47":1,"48":1,"52":1,"53":1,"55":3,"74":1,"77":1,"83":1,"85":2,"86":2,"88":1,"90":1,"95":1,"96":1,"103":1,"104":1,"105":2,"110":1,"123":1,"126":2,"131":1,"136":1,"139":1,"164":1,"167":1},"mapbox":{"1":3,"51":1,"87":3,"88":3,"89":3,"162":3,"163":2},"mapboxstyle":{"162":1,"163":1},"mapguide":{"90":3},"maps":{"5":1,"6":3,"45":1,"55":1,"125":1,"139":1,"147":1},"mapserver":{"66":1,"142":1},"maptiler":{"13":1,"24":1,"25":1,"26":1,"44":1,"46":1,"54":1,"67":1,"72":1,"76":1,"77":1,"84":1,"89":1,"91":1,"101":1,"112":1,"113":1,"125":1,"134":1,"162":2,"163":1,"169":1,"170":1,"187":1},"mapzen":{"100":1},"marker":{"58":1,"59":1,"62":1,"91":1},"max":{"75":1},"maxresolution":{"75":1},"maxzoom":{"13":1,"79":2},"measure":{"92":3},"mercator":{"187":1},"meridian":{"144":1},"min":{"75":1,"166":2},"minimum":{"166":1},"minresolution":{"75":1},"minzoom":{"13":1,"79":2},"mobile":{"1":1,"47":2,"53":1},"mode":{"43":1},"modification":{"94":1},"modify":{"28":3,"93":3,"94":2,"130":2},"mollweide":{"131":3},"mouse":{"95":3},"mousewheel":{"104":1,"105":1},"move":{"91":1},"moveend":{"96":3},"moving":{"139":1},"multiple":{"63":1,"122":2},"nad83":{"99":2},"name":{"175":1},"names":{"134":1},"navigation":{"97":3},"nexrad":{"178":1},"non":{"172":1},"not":{"104":1},"object":{"162":1},"of":{"0":1,"1":1,"3":1,"4":1,"5":1,"6":1,"9":1,"10":1,"12":1,"13":1,"16":1,"17":1,"18":1,"19":1,"20":1,"22":1,"24":1,"25":1,"26":1,"28":1,"29":1,"31":1,"32":2,"33":1,"34":1,"35":1,"36":1,"37":1,"38":1,"40":1,"42":1,"44":1,"45":1,"46":1,"47":1,"50":1,"53":1,"54":1,"55":1,"56":1,"60":1,"63":1,"65":1,"66":1,"69":1,"74":1,"76":1,"77":1,"78":1,"80":1,"82":1,"83":1,"84":1,"85":1,"88":1,"89":1,"90":1,"95":1,"96":1,"98":1,"99":1,"101":1,"103":1,"109":1,"110":1,"114":1,"115":1,"116":1,"118":1,"120":1,"121":1,"122":1,"123":1,"126":1,"127":1,"128":1,"130":1,"131":1,"132":1,"133":1,"136":1,"139":1,"142":1,"143":1,"144":1,"145":1,"148":1,"150":1,"151":1,"155":1,"157":1,"158":1,"159":1,"162":1,"164":1,"167":1,"168":1,"169":1,"170":1,"171":1,"172":1,"173":1,"177":1,"178":2,"179":1,"180":1,"181":1,"182":1,"183":2,"185":1,"186":1,"187":1,"188":1,"189":1},"offscreen":{"164":1},"offscreencanvas":{"164":1},"ol":{"10":1,"28":2,"29":1,"30":1,"43":1,"162":2,"163":2},"on":{"5":2,"51":1,"59":1,"63":1,"71":1,"75":1,"106":1,"141":1,"147":1,"149":1,"152":1,"159":1},"one":{"76":1,"139":1},"opacity":{"141":1},"opencyclemap":{"63":1},"openlayers":{"22":1,"71":1,"149":1,"152":1},"openseamap":{"83":1},"openstreetmap":{"2":1,"5":1,"8":1,"9":1,"38":1,"50":1,"52":1,"73":1,"77":1,"83":4,"85":1,"95":1,"98":3,"99":3,"100":1,"106":1,"118":1,"126":1,"139":1,"154":1,"157":1,"167":1},"operations":{"59":2,"112":1},"optimized":{"168":1},"option":{"45":1},"or":{"2":1,"105":1,"135":1},"ordering":{"78":2},"orientation":{"23":2,"53":2},"oriented":{"53":1},"osm":{"45":2,"100":2,"101":2,"111":1,"116":1,"123":1},"osmxml":{"101":1},"outside":{"95":1},"over":{"76":1},"overlay":{"102":2,"108":2},"overlays":{"102":1},"overview":{"18":2,"103":2},"overviewmap":{"18":2,"103":2},"page":{"104":3,"105":3},"pan":{"105":1,"165":1},"panning":{"105":1},"paraglider":{"63":1},"parameter":{"57":1,"183":1},"parser":{"171":1},"parsing":{"173":2,"181":2},"pattern":{"135":1},"patterns":{"135":1},"pdf":{"38":3,"110":1},"per":{"175":1},"permalink":{"106":2},"permalinks":{"106":1},"pinch":{"107":3},"pixel":{"2":1,"59":2,"112":1,"113":1,"189":1},"pixeloperation":{"119":1},"pixelwise":{"112":1},"png":{"85":2},"point":{"59":1,"61":1,"62":1,"168":1},"pointer":{"84":1},"points":{"138":2,"168":2},"polygon":{"19":3,"150":1},"polyline":{"91":1},"popover":{"102":1},"popup":{"62":1,"102":1,"108":3},"portion":{"76":1},"position":{"95":3},"positioned":{"2":1},"positioning":{"2":1},"postrender":{"41":1,"91":1},"preload":{"109":2},"preloading":{"109":1},"print":{"110":2},"printing":{"110":2},"proj4js":{"69":1,"111":1,"116":1,"128":3,"131":1},"projection":{"20":1,"69":1,"98":1,"99":1,"111":1,"116":2,"128":1,"131":1,"179":3,"189":1},"projections":{"111":1},"properties":{"125":1},"quantities":{"40":1,"168":1},"raster":{"11":1,"111":2,"112":3,"113":1,"116":1,"119":1,"124":1},"read":{"63":1,"153":1},"recorded":{"63":1},"region":{"113":2},"regiongrowing":{"113":1},"regular":{"30":1,"114":2},"regularshape":{"114":1},"relief":{"124":2},"render":{"32":1,"34":1,"115":2,"119":1,"134":1,"136":1,"168":1},"rendered":{"164":1},"renderer":{"156":1},"rendering":{"26":1,"42":1,"61":1,"70":2,"72":1,"81":1,"87":1,"115":1,"146":1,"148":1,"155":1,"164":1},"renders":{"8":1},"reprojection":{"24":1,"69":3,"98":3,"99":3,"111":3,"116":3},"request":{"170":1,"175":1},"requests":{"174":1,"176":1},"resize":{"5":1},"resolution":{"75":3},"response":{"173":1,"181":1},"rest":{"3":3,"4":1,"36":3,"186":1},"restrict":{"12":1,"107":1},"restricting":{"81":1},"retina":{"56":1,"187":3},"reusable":{"117":1},"rotate":{"27":3,"46":3},"rotated":{"167":1},"rotation":{"2":1,"165":1,"167":2},"s":{"2":1,"147":1,"166":1},"same":{"63":1},"scale":{"60":2,"110":3,"118":3},"scaleline":{"99":2,"110":1},"scaling":{"60":1},"screen":{"44":3,"45":3,"46":3,"47":2},"scroll":{"104":1,"105":1},"scrolling":{"104":2,"105":2},"sea":{"119":2},"search":{"116":1},"seed":{"113":1},"segment":{"82":1},"select":{"7":1,"59":1,"120":3,"121":2,"122":2,"161":1},"selecting":{"121":1,"122":1},"selection":{"7":2,"161":2},"semi":{"123":2},"server":{"3":1,"36":1,"83":1,"101":1,"169":1},"service":{"3":3,"36":3},"setting":{"80":1,"150":1},"shaded":{"124":2},"shadedrelief":{"124":1},"shadow":{"17":1},"shape":{"34":1,"114":1},"shapes":{"30":2,"114":1},"share":{"125":1},"shared":{"125":1},"should":{"184":1},"show":{"75":1,"84":1},"showing":{"19":1,"135":1,"163":1},"shows":{"15":1,"21":1,"86":1,"97":1,"104":1,"105":1,"153":1,"175":1},"side":{"69":1,"98":1,"99":1,"111":1,"116":1,"125":2},"simple":{"9":1,"88":1,"89":1,"126":3},"single":{"27":1,"69":1,"127":2,"128":1,"175":1},"singleimage":{"128":1},"slice":{"51":1},"slider":{"188":1},"sliders":{"188":1},"small":{"5":1},"smooth":{"129":2,"178":1,"183":1},"smoothing":{"24":2,"129":2},"snap":{"130":3,"150":2},"so":{"2":1},"some":{"114":1},"source":{"4":1,"9":1,"10":1,"11":1,"32":1,"45":3,"54":1,"65":1,"69":1,"72":1,"80":3,"101":1,"112":2,"117":2,"132":1,"153":1,"174":1,"176":1,"180":1,"182":1,"185":1,"186":1,"189":1},"specific":{"2":1},"specified":{"110":1},"sphere":{"131":2},"sprite":{"40":1,"61":1},"sprites":{"61":1},"spy":{"76":2},"square":{"114":1,"172":1},"stamen":{"132":3},"star":{"114":1},"static":{"133":2},"staticimage":{"133":1},"strategy":{"3":1,"101":1,"169":1},"street":{"134":2},"streets":{"134":1},"string":{"82":1},"studio":{"87":1},"style":{"19":2,"32":2,"33":1,"34":1,"35":1,"58":1,"59":1,"60":1,"62":1,"87":1,"114":1,"135":1,"146":1,"148":1,"162":3,"163":2,"188":1},"styled":{"135":1,"163":1},"styles":{"19":1,"114":1},"styling":{"135":1,"188":1},"svg":{"136":3},"swipe":{"77":3},"symbol":{"35":1,"114":1},"symbolize":{"62":1},"symbolizer":{"34":1,"62":1},"symbols":{"35":2},"synthetic":{"137":2,"138":2},"tabindex":{"0":1},"target":{"139":1},"teleport":{"139":1},"teleporting":{"139":1},"terrain":{"132":1},"test":{"94":1},"testing":{"94":1},"that":{"104":1,"105":1,"144":1,"164":1},"the":{"19":1,"21":1,"25":1,"26":1,"28":2,"29":1,"30":1,"32":1,"33":1,"34":1,"35":1,"43":1,"48":1,"51":2,"54":1,"57":1,"63":1,"70":1,"84":1,"93":1,"95":1,"96":1,"101":1,"105":1,"117":1,"120":1,"130":1,"135":1,"144":1,"166":1,"171":1,"178":1,"179":2,"183":1},"them":{"5":1},"this":{"2":1,"21":1,"86":1,"129":1,"153":1,"184":1},"tile":{"1":1,"3":1,"20":1,"55":2,"83":1,"98":1,"99":1,"109":1,"117":1,"132":1,"140":3,"141":1,"142":1,"143":1,"144":1,"160":1,"161":1,"172":1,"176":1,"178":1,"183":2},"tiled":{"20":1,"142":2,"143":2,"144":2,"176":1,"178":1},"tilejson":{"74":1,"81":1,"123":1,"145":3,"153":1},"tilelayer":{"20":1,"142":1,"143":1},"tiles":{"1":3,"4":2,"8":2,"51":2,"55":1,"87":1,"88":3,"89":1,"100":3,"109":1,"132":1,"141":1,"160":1,"161":1,"162":2,"163":2,"164":2,"172":2,"186":1,"187":2},"tilesize":{"4":1},"tilesource":{"65":1},"time":{"178":3},"timezones":{"146":2},"tissot":{"147":3},"to":{"5":1,"7":1,"14":1,"15":1,"21":1,"23":1,"27":1,"30":1,"32":1,"34":1,"35":1,"39":1,"40":1,"41":1,"52":1,"58":1,"62":1,"67":1,"71":1,"79":1,"81":1,"86":2,"91":1,"92":1,"97":1,"99":1,"105":1,"106":1,"107":1,"108":1,"110":2,"115":2,"116":1,"129":1,"139":1,"149":1,"150":2,"152":1,"153":1,"164":1,"168":1,"175":1,"179":1},"tocontext":{"35":1},"together":{"22":1,"28":1,"130":1},"tolerance":{"57":1},"tooltip":{"21":1,"34":1},"tooltips":{"21":2},"topojson":{"25":1,"26":1,"148":3},"topolis":{"149":3},"topology":{"148":1,"149":1,"150":1},"trace":{"150":1},"tracing":{"150":1},"tracking":{"53":1},"trackpad":{"104":1,"105":1},"tracks":{"63":1},"transform":{"20":1,"136":1},"transforms":{"128":1},"transition":{"141":1,"178":1,"183":1},"transitions":{"141":2,"178":1,"183":2},"translate":{"151":3},"transparent":{"123":3},"triangle":{"114":1},"turf":{"152":2},"turfjs":{"152":1},"two":{"105":1,"125":1,"132":1,"179":1},"ufo":{"61":1},"under":{"84":1},"unknown":{"179":1},"unless":{"105":1},"untiled":{"90":2},"up":{"150":1},"updatefeature":{"36":1},"updating":{"117":1},"url":{"117":1},"use":{"32":1,"33":1,"34":1,"35":1,"71":1,"96":1,"149":1,"152":1},"used":{"105":1},"uses":{"108":1,"129":1},"using":{"3":1,"4":1,"7":1,"10":1,"20":1,"22":1,"25":1,"26":1,"28":1,"29":1,"30":1,"36":1,"39":1,"40":1,"43":1,"48":1,"52":1,"54":1,"57":1,"62":1,"68":1,"70":1,"78":1,"79":1,"92":1,"100":1,"101":1,"120":1,"129":1,"130":1,"140":1,"162":1,"163":1,"168":1,"169":1,"171":1,"174":1,"179":1,"186":1},"utfgrid":{"153":3},"various":{"111":1,"188":1},"vector":{"1":3,"3":1,"10":1,"14":1,"16":1,"19":1,"26":4,"28":1,"29":1,"30":1,"32":1,"33":1,"34":1,"35":1,"36":1,"41":1,"42":1,"43":1,"50":1,"51":2,"58":1,"59":1,"60":1,"62":1,"71":1,"72":1,"82":1,"87":2,"88":3,"89":1,"92":1,"93":1,"94":1,"100":3,"101":1,"114":1,"120":1,"121":1,"122":1,"130":1,"134":1,"135":1,"137":1,"138":1,"146":1,"148":1,"149":1,"150":1,"151":1,"152":1,"154":3,"155":3,"156":2,"157":2,"158":3,"159":3,"160":2,"161":2,"162":1,"163":2,"164":2,"169":1,"170":1},"vectortiles":{"160":1,"161":1,"162":1,"163":1},"version":{"84":1},"vertices":{"19":1},"view":{"2":2,"12":2,"13":1,"48":1,"52":1,"75":1,"76":1,"125":1,"165":1,"166":2,"167":1},"views":{"125":1},"visibility":{"79":1},"visibily":{"5":1},"vt":{"51":1},"watercolor":{"132":1},"web":{"17":1},"webgl":{"33":1,"40":3,"61":3,"168":3},"wellknowntext":{"171":1},"wfs":{"169":3,"170":3},"wgs84":{"98":2},"when":{"178":1,"183":1},"which":{"179":1},"with":{"1":1,"3":1,"4":1,"8":1,"11":1,"12":1,"17":1,"18":1,"19":1,"21":1,"26":1,"28":1,"35":1,"40":1,"41":1,"45":2,"46":1,"49":1,"53":1,"55":1,"61":2,"70":1,"71":1,"72":1,"74":1,"83":1,"87":1,"93":1,"99":1,"112":1,"116":1,"123":1,"128":1,"130":1,"131":1,"135":2,"136":1,"149":1,"152":1,"156":1,"157":1,"158":1,"159":1,"162":1,"169":1,"170":1,"172":1,"174":1,"176":1},"without":{"179":1},"wkt":{"171":3},"wms":{"20":2,"111":1,"127":3,"128":2,"143":3,"144":3,"172":3,"173":3,"174":2,"175":2,"176":2,"177":3,"178":3,"179":3},"wmts":{"56":3,"64":3,"111":1,"180":3,"181":3,"182":4,"183":3},"worker":{"164":2,"184":2},"wrap":{"144":1},"wrapping":{"144":1},"wraps":{"144":1},"x":{"114":1},"xkcd":{"133":1},"xml":{"101":2},"xyz":{"4":2,"24":1,"44":1,"46":1,"125":1,"185":3,"186":3,"187":3},"z":{"78":3},"zoom":{"13":3,"27":3,"46":3,"79":1,"104":1,"105":1,"107":3,"165":1,"166":3,"188":2},"zoomify":{"189":3},"zooming":{"107":1},"zoomslider":{"188":2}}};